var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.setupCI=exports.decrypt=exports.encrypt=void 0;var _path=_interopRequireDefault(require("path"));
var _tar=_interopRequireDefault(require("tar"));
var _chalk=_interopRequireDefault(require("chalk"));
var _fs=_interopRequireDefault(require("fs"));
var _common=require("../common");
var _fileutils=require("./fileutils");
var _exec=require("./exec");

var getEnvVar=function getEnvVar(c){
var p1=c.paths.globalConfigFolder.split('/').pop().replace('.','');
var p2=c.files.projectPackage.name.replace('@','').replace('/','_').replace(/-/g,'_');
var envVar=("CRYPTO_"+p1+"_"+p2).toUpperCase();
(0,_common.logDebug)('encrypt looking for env var:',envVar);
return envVar;
};

var encrypt=function encrypt(c){return new Promise(function(resolve,reject){var _c$files$projectConfi,_c$files$projectConfi2,_c$files$projectConfi3;
(0,_common.logTask)('encrypt');

var source="./"+c.files.projectPackage.name;
var destRaw=(_c$files$projectConfi=c.files.projectConfig)==null?void 0:(_c$files$projectConfi2=_c$files$projectConfi.crypto)==null?void 0:(_c$files$projectConfi3=_c$files$projectConfi2.encrypt)==null?void 0:_c$files$projectConfi3.dest;

if(destRaw){
var dest=""+(0,_fileutils.getRealPath)(c,destRaw,'encrypt.dest');
var destTemp=_path.default.join(c.paths.globalConfigFolder,c.files.projectPackage.name.replace('/','-'))+".tgz";

var envVar=getEnvVar(c);
var key=c.program.key||c.process.env[envVar];
if(!key){
reject("encrypt: You must pass "+_chalk.default.white('--key')+" or have env var "+_chalk.default.white(envVar)+" defined");
return;
}
_tar.default.c(
{
gzip:true,
file:destTemp,
cwd:c.paths.globalConfigFolder},

[source]).

then(function(){return(0,_exec.executeAsync)('openssl',[
'enc',
'-aes-256-cbc',
'-salt',
'-in',
destTemp,
'-out',
dest,
'-k',
key]);}).

then(function(){
(0,_fileutils.removeFilesSync)([destTemp]);
resolve();
}).catch(function(e){
reject(e);
});
}else{
(0,_common.logWarning)("You don't have {{ crypto.encrypt.dest }} specificed in "+_chalk.default.white(c.paths.projectConfig));
resolve();
}
});};exports.encrypt=encrypt;

var decrypt=function decrypt(c){return new Promise(function(resolve,reject){var _c$files$projectConfi4,_c$files$projectConfi5,_c$files$projectConfi6;
(0,_common.logTask)('encrypt');

var sourceRaw=(_c$files$projectConfi4=c.files.projectConfig)==null?void 0:(_c$files$projectConfi5=_c$files$projectConfi4.crypto)==null?void 0:(_c$files$projectConfi6=_c$files$projectConfi5.decrypt)==null?void 0:_c$files$projectConfi6.source;

if(sourceRaw){
var source=""+(0,_fileutils.getRealPath)(c,sourceRaw,'decrypt.source');
var destTemp=_path.default.join(c.paths.globalConfigFolder,c.files.projectPackage.name.replace('/','-'))+".tgz";
var envVar=getEnvVar(c);

var key=c.program.key||c.process.env[envVar];
if(!key){
reject("encrypt: You must pass "+_chalk.default.white('--key')+" or have env var "+_chalk.default.white(envVar)+" defined");
return;
}
(0,_exec.executeAsync)('openssl',[
'enc',
'-aes-256-cbc',
'-d',
'-in',
source,
'-out',
destTemp,
'-k',
key]).

then(function(){
_tar.default.x(
{
file:destTemp,
cwd:c.paths.globalConfigFolder}).

then(function(){
(0,_fileutils.removeFilesSync)([destTemp]);
(0,_common.logSuccess)("Files succesfully extracted into "+c.paths.globalConfigFolder);
resolve();
}).
catch(function(e){return reject(e);});
}).catch(function(e){
reject(e);
});
}else{
(0,_common.logWarning)("You don't have {{ crypto.encrypt.dest }} specificed in "+_chalk.default.white(c.paths.projectConfig));
resolve();
}
});};exports.decrypt=decrypt;

var setupCI=function setupCI(c){
(0,_common.logTask)('setupCI');
if(c.platform==='ios')return _setupAppleCI(c);

(0,_common.logError)("setupCI: platform "+c.platform+" not supported");
return Promise.resolve();
};exports.setupCI=setupCI;

var _setupAppleCI=function _setupAppleCI(c){return new Promise(function(resolve,reject){
(0,_common.logTask)('_setupAppleCI');
var ppFolder=_path.default.join(c.paths.homeFolder,'Library/MobileDevice/Provisioning Profiles');
var kChain='ios-build.keychain';
var kChainPath=_path.default.join(c.paths.homeFolder,'Library/Keychains',kChain);
var tempPass='***********';

if(!_fs.default.existsSync(ppFolder)){
(0,_common.logWarning)("folder "+ppFolder+" does not exist!");
(0,_fileutils.mkdirSync)(ppFolder);
}

var list=(0,_fileutils.getFileListSync)(c.paths.globalProjectFolder);
var cerPromises=[];
var mobileprovisionArr=list.filter(function(v){return v.endsWith('.mobileprovision');});
var cerArr=list.filter(function(v){return v.endsWith('.cer');});

try{
mobileprovisionArr.forEach(function(v){
(0,_fileutils.copyFileSync)(v,ppFolder);
});
(0,_fileutils.copyFileSync)(_path.default.join(c.paths.rnvRootFolder,'src/platformTools/apple/supportFiles/AppleWWDRCA.cer'),ppFolder);
}catch(e){
(0,_common.logError)(e);
}







Promise.all(cerArr.map(function(v){return(0,_exec.executeAsync)('security',[
'import',
v,
'-k',
kChain,
'-A']);})).

then(function(){return resolve();}).
catch(function(e){
(0,_common.logWarning)(e);
resolve();
});
});};